#!/usr/bin/python

program_name = "mt"
program_version = "0.2"


import pygtk
pygtk.require("2.0")
import gtk

from tktk import runqueue


class clockwin:
  def __init__(self, cfg):
    self.cfg = cfg
    self.done = 0
    self.ac_on = 0
    self.batt_px = 0.0
    self.mt = None

    self.win = gtk.Window(self.cfg.window_type)
    #self.win = gtk.Window()
    self.win.connect("destroy", self.destroy)
    #self.win.set_position(POS_RIGHT|POS_TOP)
    #self.win.set_uposition(self.cfg.x, self.cfg.y)
    self.win.move(self.cfg.x, self.cfg.y)
    #self.win.set_transient_for(None)
    #self.win.set_wmclass("mt", WINDOW_TOPLEVEL)
    

    self.hbox = gtk.HBox()
    self.win.add(self.hbox)

    self.label = gtk.Label()
    self.label.set_text("??.???")
    self.label.set_size_request(self.cfg.label_wid, self.cfg.label_hgt)
    self.hbox.add(self.label)

  def run(self):
    import time

    self.win.show_all()

    sleeptime = self.cfg.sleep_time

    if self.cfg.style == "swatch":
      self.multiplier = 1000
      self._text = self._swatch_time
    elif self.cfg.style == "millidays":
      self.multiplier = 1000.0
      self._text = self._milliday_time
    elif self.cfg.style == "centidays":
      self.multiplier = 100.0
      self._text = self._centiday_time

    while not self.done:
      self.get_info()
      self.update()
      runqueue()
      time.sleep(sleeptime)

  def _swatch_time(self, mt):
    """D'oh.  Python's "%02.3f" doesn't zero-pad the front of a float."""
    return "@%03i" % (mt)

  def _milliday_time(self, mt):
    frac = "%.2f" % (mt % 1.0)
    return "%s%s" % ("%03i" % (mt), frac[1:])

  def _centiday_time(self, mt):
    frac = "%.3f" % (mt % 1.0)
    return "%s%s" % ("%02i" % (mt), frac[1:])

  def get_info(self):
    import time

    if self.cfg.style == "swatch":
      offset = 1 - time.daylight
      t = time.localtime(time.mktime(time.gmtime()) - (60*60*offset))
      #t = time.gmtime(time.mktime(time.gmtime()))
      #t = time.gmtime()
    elif self.cfg.local_time:
      t = time.localtime()
    else:
      t = time.gmtime()
    self.year = t[0]
    self.month = t[1]
    self.day = t[2]
    t2 = time.time() % 1.0
    secs = t2 + t[5] + (60 * t[4]) + (60 * 60 * t[3])

    self.mt = self.multiplier * secs / (60 * 60 * 24)

    #print self.mt
    #print "%.3f" % (self.mt * 1000.0)

  def update(self):
    self.timestring = ""
    if self.cfg.date:
      self.timestring = "%s%s-%02i-%02i   " % \
                        (self.timestring, self.year, self.month, self.day)
    if self.cfg.time:
      #self.timestring = "%s%s" % (self.timestring, self.timeformat % (self.mt))
      self.timestring = "%s%s" % (self.timestring, self._text(self.mt))

    #print self.timestring

    self.label.set_text(self.timestring)

  def destroy(self, *args):
    #mainquit()
    self.done = 1

def run(args):
  import pycfg
  cfg = pycfg.config(program_name)
  cfg.load()
  
  cw = clockwin(cfg)
  cw.run()

if __name__ == "__main__":
  import sys
  run(sys.argv[1:])
